<template>
  <q-page class="q-pa-md">
    
    <h1>Communities</h1>

    <q-list bordered separator v-if="communities.length">
      <Community
        v-for="community in communities"
        :key="community.id"
        v-bind="community"
      />
    </q-list>

    <div v-if="!communities.length">
      Noch keine Datenstruktur vorhanden. Diese kann über den Reset Button initialisiert werden.
    </div>

    <div class="q-mt-xl full-width">
      <q-btn outline v-if="isAdmin" :to="{ name: 'reset', params: { idCommunity: idCommunity } }">Reset</q-btn>
    </div>

  </q-page>
</template>

<script>
import Community from "src/components/Community";
import { defineComponent, ref as refVue } from "vue";
import { mapGetters } from "vuex";
import { getDatabase, ref, set, get, onValue, orderByKey, orderByValue } from "firebase/database";

export default defineComponent({
  name: "PageIndex",
  components: {
    Community,
  },
  computed: {
    ...mapGetters({
      user: "counter/getUser",
      isAdmin: "counter/isAdmin"
    }),
  },
  setup() {
    
    let communities = refVue([]);
    const db = getDatabase();

    get(ref(db, "communities/")).then((snapshot) => {

        const data = snapshot.val();
        communities.value = [];

        Object.keys(data).forEach((entry) => {
          communities.value.push({ id: entry, label: data[entry].label });
        });
      })
      .catch((error) => {
        console.error(error);
      });

    return {
      communities
    };
  },
});
</script>
